/*
 * The Cryptonit security software suite is developped by IDEALX
 * Cryptonit Team (http://IDEALX.org/ and http://cryptonit.org).
 *
 * Copyright ? 2003 IDEALX
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */


#include "Contact.hh"


namespace Cryptonit
{

    Contact::Contact()
    {
	contactInfo = new Entry();
    }
    

    Contact::Contact( const std::string name )
    {
	contactInfo = new Entry();
	contactName = name;
    }

    
    Contact::Contact( const std::string name, const Entry& info )
    {
	contactInfo = new Entry( info );
	contactName = name;
    }


    Contact::Contact( const std::string name, Entry* info )
    {
	contactInfo = new Entry(info);
	contactName = name;
    }


    Contact::~Contact()
    {
	delete contactInfo;
    } 
    

    std::string Contact::getName() 
    {
	return( contactName );
    }


    Entry* Contact::getInfo()
    {
	return( contactInfo ) ;
    }


    std::string Contact::getInfo( std::string infoName )
    {
	return( contactInfo->getAttributeFirstValue( infoName ) );
    }


    bool Contact::setInfo( const Entry& info )
    {
	return false;
    }
    
    bool Contact::setInfo( const Entry* info )
    {
	return false;
    }

    bool Contact::setInfo( const std::string infoName, const std::string value )
    {
	if( contactInfo->getAttributeFirstValue( infoName ) != "" )
	    if( contactInfo->erase( infoName ) ) 
		return contactInfo->append( infoName, new Attribute(value) );
	return contactInfo->append( infoName, new Attribute(value) );
    }

    bool Contact::removeInfo( const std::string infoName )
    {
	return contactInfo->erase( infoName );
    }
}
