
void ContactDlg::setInfo(Entry* contact, User* u){
    
    user = u;
  
    // initialize values
  // Values 
  // First tab 
   firstNameText->setText(QString(contact->getAttributeFirstValue("cn").c_str()));
   lastNameText->setText(QString(contact->getAttributeFirstValue("sn").c_str()));
   displayNameText ->setText(QString(contact->getAttributeFirstValue("name").c_str()));
   nicknameText->setText(QString(contact->getAttributeFirstValue("givenName").c_str()));

   emailText->setText(QString(contact->getAttributeFirstValue("mail").c_str()));
   email2Text ->setText(QString(contact->getAttributeFirstValue("mail2").c_str()));
   screenNameText ->setText(QString(contact->getAttributeFirstValue("displayName").c_str()));
  
  // Second tab 
   titleText->setText(QString(contact->getAttributeFirstValue("title").c_str()));
   departmentText->setText(QString(contact->getAttributeFirstValue("ou").c_str()));
   organizationText->setText(QString(contact->getAttributeFirstValue("o").c_str()));
   workAddressText->setText(QString(contact->getAttributeFirstValue("workStreet").c_str()));
   workAddress2Text->setText(QString(contact->getAttributeFirstValue("workStreet2").c_str()));
   workCityText ->setText(QString(contact->getAttributeFirstValue("workLocation").c_str()));
   workStateText ->setText(QString(contact->getAttributeFirstValue("workState").c_str()));
   workZipText ->setText(QString(contact->getAttributeFirstValue("workPostalCode").c_str()));
   workCountryText->setText(QString(contact->getAttributeFirstValue("workCo").c_str()));
   workwwwText->setText(QString(contact->getAttributeFirstValue("workWww").c_str()));

   QString certFileName( contact->getAttributeFirstValue("userCertificate").c_str()); 
   certFileName = user->getCertificatesDir() + QDir::separator() + certFileName;
   
   std::cout << "setInfo::certFileName: " << certFileName << std::endl;
 
   if(contact->getAttributeFirstValue("userCertificate") != ""){
       cert = new Certificate();
       if(cert->load(certFileName.latin1())!=SUCCESS){
	   delete cert;
	   cert = NULL;
       }
   }
   else {
       cert= new Certificate( );
       if(cert->load((void*)contact->getAttributeFirstValue("userCertificate;binary").c_str(),contact->getAttributeFirstValue("userCertificate;binary").size() ) !=SUCCESS){
	   delete cert;
	   cert = NULL;
       }
       
   }       
}


bool ContactDlg::setUser(QString &filename, Cryptonit::User* u) {
    user = u;
    
    cert = new Certificate ();
    if(cert->load(filename.latin1()) != SUCCESS) {	
	delete cert;
	cert = NULL;
	QMessageBox::critical(this, QString("Assinador"),  "O certificado no pode ser carregado ou o arquivo no  um certificado do tipo X.509.");
	return false;
    }
    else{
	firstNameText->setText(QString(cert->getSubjectName().getValue("CN").c_str()));	
	departmentText->setText(QString(cert->getSubjectName().getValue("OU").c_str()));
	organizationText->setText(QString(cert->getSubjectName().getValue("O").c_str()));
	workCountryText->setText(QString(cert->getSubjectName().getValue("C").c_str()));
	workCountryText ->setText(QString(cert->getSubjectName().getValue("C").c_str()));

	emailText->setText(QString(cert->getEmailAddress().c_str()));
	return true;	
    }
}

void ContactDlg::createFieldTab(){
    int i = 0;
    fieldsTab[i++]= QString("cn");
    fieldsTab[i++]= QString("sn");
    fieldsTab[i++]= QString("name");
    fieldsTab[i++]= QString("givenName");
    fieldsTab[i++]= QString("mail");
    fieldsTab[i++]= QString("mail2");
    fieldsTab[i++]= QString("displayName");
    
    
    fieldsTab[i++] = QString("title");
    fieldsTab[i++] = QString("ou");
    fieldsTab[i++] = QString("o");
    fieldsTab[i++] = QString("workStreet");
    fieldsTab[i++] = QString("workStreet2");
    fieldsTab[i++] = QString("workLocation");
    fieldsTab[i++] = QString("workState");
    fieldsTab[i++] = QString("workPostalCode");
    fieldsTab[i++] = QString("workCo");
    fieldsTab[i++] = QString("workWww");
    
    createContactTab();
	
}

void ContactDlg::createContactTab(){
    int i = 0;
    
   ctrlTab[i++]= firstNameText->text();
   ctrlTab[i++]= lastNameText->text();
   ctrlTab[i++]= displayNameText ->text();
   ctrlTab[i++]= nicknameText->text();

   ctrlTab[i++]= emailText->text();
   ctrlTab[i++]= email2Text ->text();
   ctrlTab[i++]= screenNameText ->text();
  
  // Second tab
   ctrlTab[i++]= titleText->text();
   ctrlTab[i++]= departmentText->text();
   ctrlTab[i++]= organizationText->text();
   ctrlTab[i++]= workAddressText->text();
   ctrlTab[i++]= workAddress2Text->text();
   ctrlTab[i++]= workCityText ->text();
   ctrlTab[i++]= workStateText ->text();
   ctrlTab[i++]= workZipText ->text();
   ctrlTab[i++]= workCountryText->text();
   ctrlTab[i++]= workwwwText->text();
	
}

int ContactDlg::addContact(Cryptonit::User *u,QString filename){
    
    createFieldTab();
        
    // we save this contact's certificate 
    Certificate *certificate = new Certificate();;
    std::cerr << "loading "<< filename << std::endl;
    std::cout << "addContact Cert #1 " << std::endl;
    if( certificate->load(filename.latin1())!= SUCCESS){
	std::cerr << "error while loading "<< filename << std::endl;
	std::cout << "error while loading "<< filename << std::endl;
	return -1;
    }
    std::cout << "addContact Cert #2 " << std::endl;
    std::string certHash = certificate->getHash();
    QString certFile(certHash.c_str());
    certFile+=".der";
    certFile=(u->getCertificatesDir().c_str())+QString("/")+certFile;
    if(certificate->save(certFile.latin1()) != SUCCESS){
	return -2;
    }
    
    
    Contact *contact = new Contact(certificate->getSubjectName().getValues(DN_DISPLAY_SHORT | DN_DISPLAY_VALUE, '/'));
    contact->setInfo("userCertificate", (QString(certHash.c_str())+".der").latin1());
    delete certificate;    
    
    for(int i=0 ; i < 17 ; i++){
	if(!ctrlTab[i].isEmpty() && !fieldsTab[i].isEmpty()){
	    std::cout << fieldsTab[i].latin1() << "=" << ctrlTab[i].latin1() << std::endl;
	    contact->setInfo(fieldsTab[i].latin1(), ctrlTab[i].latin1());
	}
    }
    
    
    if( ! u->addressBook->addContact( contact ) ) {
	return -3;
    }

	
    return SUCCESS; 
}



int ContactDlg::saveContact(Cryptonit::Entry* entry) {
    createFieldTab();
	
    for(int i=0 ; i < 17 ; i++){
	std::string infoName = fieldsTab[i].latin1();
	std::string value = ctrlTab[i].latin1();
	if(!ctrlTab[i].isEmpty() && !fieldsTab[i].isEmpty()) {
	    if( entry->getAttributeFirstValue( infoName ) != "" )
		if( entry->erase( infoName ) ) 
		    entry->append( infoName, new Attribute(value) );
	    entry->append( infoName, new Attribute(value) );
	}
    }
    
    return SUCCESS; 
}


int ContactDlg::viewCertificate(){
    if(cert != NULL){
	
	CertificateViewer cv(this);
	
	cv.init(*cert, user, true);
	
	cv.exec();
	
	return SUCCESS;
    }
    return -1;
}
    

void ContactDlg::certifBtn_clicked()
{
    viewCertificate();
    
}


