#ifndef GENERIC_DATA_LISTVIEW_ITEM
#define GENERIC_DATA_LISTVIEW_ITEM

#include <qlistview.h>
#include <qlistbox.h>
#include <qstring.h>

class GenericDataListViewItem : public QListViewItem
{
public:
  GenericDataListViewItem(QListView *parent, void *_data, QString c1, QString c2=QString::null, QString c3=QString::null, QString c4=QString::null);
  GenericDataListViewItem(QListViewItem *parent, void *_data, QString c1, QString c2=QString::null, QString c3=QString::null, QString c4=QString::null);
  void* getData();

private:
  void *data;
};

//----------------------------

class GenericDataListBoxItem : public QListBoxText 
{
public:
  GenericDataListBoxItem(QListBox * listbox, void* _data, QString label);
  void* getData();
  
private:
  void *data;
};

//----------------------------

#include <string>

class CATreeItemData
{
  public:
    CATreeItemData(const std::string& certFilename, const std::string& dn, const std::string& sdn) 
    : m_certFilename(certFilename), m_dn(dn), m_shortDn(sdn) {}
    const std::string GetCertFilename() const { return m_certFilename; }
    const std::string GetDN() const { return m_dn; }
    const std::string GetShortDN() const { return m_shortDn; }

  private:
    std::string m_certFilename;
    std::string m_dn;
    std::string m_shortDn;
};


#endif
