/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/

#include <qdir.h>
#include <qpixmap.h>
#include <qlineedit.h>
#include <qcombobox.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qstringlist.h>
#include <qlistbox.h>
#include <qmessagebox.h>
#include <qfiledialog.h>
#include <qinputdialog.h>
#include <qapplication.h>

#include "User.hh"
#include "Utils.hh"
#include "Crl.hh"

#include "Certificate.hh"

#include <string>
#include <vector>

#include "MainWindow.h"
#include "GPLdialog.h"
#include "NewUserWizard.h"

// #include "pathinfo.h"

void LoginFrame::init()
{
  //   setWFlags(WStyle_Customize);

  user = 0;
  setResult(QDialog::Rejected);
      
  mLicenseAccepted = true;
  setupImages();

  setControlsEnabled(false);

  dirHome = QDir::homeDirPath();
  dirHome += "/.assinador";

  pwdCtrl->setEchoMode(QLineEdit::Password);

  fillUsersList();

  // Check if there is already created users, if not, prompt
  // for the new user wizard.
  if( loginBox->count() == 0 )
  {
    GPLDialog* gpl = new GPLDialog(this);
    int ret = gpl->exec();
//     delete gpl;
    if(ret == QDialog::Rejected )
    {
      mLicenseAccepted = false;
      return;
    }    

    QString wizmsg = "Parece que  a primeira vez que o Assinador  executado. "
                     "Deseja criar um novo usurio agora?";

    if(QMessageBox::question( this, "Pergunta",  wizmsg, QMessageBox::Yes, QMessageBox::No) == QMessageBox::Yes)
    {
      slotWizard();
    }

    pwdCtrl->setFocus();
  }
  else
  {
    loginBox->setCurrentItem(0);
    pwdCtrl->setFocus();
  }

  setControlsEnabled(true);
  
  setFixedSize(QSize(400,300));
  
  QDialog::show();
}

void LoginFrame::setControlsEnabled(bool value)
{
  if(value)
  {
    loginText->show();
    passwdText->show();
    newUserText->show();
    loginBox->show();
    pwdCtrl->show();

    okButton->show();
    quitButton->show();
    newUserButton->show();
  }
  else
  {
    loginText->hide();
    passwdText->hide();
    newUserText->hide();
    loginBox->hide();
    pwdCtrl->hide();

    okButton->hide();
    quitButton->hide();
    newUserButton->hide();
  }
}


void LoginFrame::setupImages()
{
//   setPaletteBackgroundPixmap(QPixmap(dataPath() + "/pics/login.xpm"));
  loginText->setBackgroundOrigin(QWidget::ParentOrigin);
  passwdText->setBackgroundOrigin(QWidget::ParentOrigin);
  newUserText->setBackgroundOrigin(QWidget::ParentOrigin);
  loginBox->setBackgroundOrigin(QWidget::ParentOrigin);
  pwdCtrl->setBackgroundOrigin(QWidget::ParentOrigin);
  okButton->setBackgroundOrigin(QWidget::ParentOrigin);
  quitButton->setBackgroundOrigin(QWidget::ParentOrigin);
  newUserButton->setBackgroundOrigin(QWidget::ParentOrigin);
//
//   okButton->setPixmap(QPixmap(dataPath() + "/pics/verify_ok.xpm"));
//   quitButton->setPixmap(QPixmap(dataPath() + "/pics/verify_notok.xpm"));
//   newUserButton->setPixmap(QPixmap(dataPath() + "/pics/newuser2.xpm"));
}

void LoginFrame::slotLogin()
{
  if(loginBox->count())
  {
    LOGIN = loginBox->text(loginBox->currentItem());
  }

  PWD = pwdCtrl->text();

//   Cryptonit::User* user;

  if(!LOGIN.isEmpty())
  {
    user = new Cryptonit::User(LOGIN.latin1());
  }
  else
  {
    user = new Cryptonit::User();
  }

  std::string hashc = user->getInfo("Password");
  std::string c = encryptPassword(PWD.latin1(), "1" , (getSalt(hashc.c_str())).c_str() );

  if((c == hashc))
  {

    //thiago: NOTE: Nao estamos fazendo internacionalization pro enquanto

    /* Use the local stored in the user's preferences */
    //     std::string language = user->getInfo("Language");
    /* Get a reference on the app
      * for accessing locales methods
    */

    //     CryptonitGui& app = wxGetApp();
    //     app.setCurrentLocale( language.c_str() );


    /* Loading local address book */
    std::string localAddressBook = "config://";
    localAddressBook += user->getAddressBookFile();

    user->addressBook = new Cryptonit::AddressBook( localAddressBook );

    if( user->addressBook == NULL )
    {
      QString msg = "No foi possvel criar sua lista de contatos pessoal (";
      msg += user->getAddressBookFile().c_str();
      msg += ")";
      QMessageBox::critical(this, "Erro", msg);
      return;
    }

    /* Load authorities database */
    std::string authoritiesDB = "config://";
    authoritiesDB += user->getCAFile();

    user->authorities = new Cryptonit::AuthoritiesDB( authoritiesDB );

    if( user->authorities == NULL )
    {
      QString msg = "No foi possvel carregar seu banco de dados pessoal de certificado de autoridades. ( ";
      msg += user->getCAFile().c_str();
      msg += ")";
      QMessageBox::critical(this, "Erro", msg);
      return;
    }


    // Check if the user have only a certificate request pending
    // no P12 entries in the Preferences file
    std::vector<std::string> pkcs12s;
    pkcs12s = user->getInfos( "PKCS12" );

    if( pkcs12s.size() == 0 )
    {
      std::cout << "Certificate request pending in " << user->getP12Dir() << std::endl;
      // a private key and a certificate request in the P12/ dir
      QDir dir(user->getP12Dir().c_str());
      //       if(dir.IsOpened())
      if(dir.isReadable())
      {
        QStringList files;
        files = dir.entryList();

        // there can be only 2 files: private key and request
        if( dir.count() == 2 )
        {
          QStringList::iterator it = files.begin();

          //           char buffer1[60], buffer2[60];
          QString buffer3, buffer4;
          QFile first(files[0]), second(files[1]);

          if(!(first.open(IO_ReadOnly )  && second.open(IO_ReadOnly)))
          {
            QString msg = "No foi possvel abrir arquivos de certificado.";
            QMessageBox::critical(this, "Erro", msg);
            return;
          }

          buffer3 = first.readAll().data();
          buffer4 = second.readAll().data();

          if( ((buffer3.find("-----BEGIN RSA PRIVATE KEY-----") == 0)
               && (buffer4.find("-----BEGIN CERTIFICATE REQUEST-----") == 0))
              || ((buffer3.find("-----BEGIN CERTIFICATE REQUEST-----") == 0)
                  && (buffer4.find("-----BEGIN RSA PRIVATE KEY-----") == 0)) )
          {

            // We can close the files
            first.close();
            second.close();

            // Ok, show the user a message box prompting him for
            // importing the signed certificate
            QString msg;
            msg = "Voc tem uma requisio de certificado pendente. Deseja import-la agora?";
            if(QMessageBox::question( this, "Pergunta",  msg, QMessageBox::Yes | QMessageBox::No) == QMessageBox::Yes)
            {
              // Prompt the user for the signed certificate
              QString wildcard;
              wildcard = "Todos os formatos suportados (*.cer *.crt *.der *.pem);;"
                         "Certificado (*.cer *.crt)"
                         "Certificado codificado em DER (*.der)"
                         "Certificado codificado em PEM (*.pem)";

              QString filePath = QFileDialog::getOpenFileName(QDir().path(),
                                 wildcard, this, "Escolha uma requisio de certificado assinado");

              if( !filePath.isEmpty() )
              {
                //                 wxFileName certFilename(fileDlg.GetFilename());
                //                 certFilename.AppendDir(fileDlg.GetDirectory());

                Cryptonit::Certificate certificate;

                if( certificate.load(filePath) != 0 )
                {
                  QMessageBox::critical(this, "Erro", "Esse certificado parece ser invlido.");
                  return;
                }

                // Search the corresponding request and private key in the P12/ dir
                std::string privateKey, certificateRequest;
                if( buffer3.find("-----BEGIN RSA PRIVATE KEY-----") == 0)
                {
                  // first is the private key, so second is the request
                  privateKey = files[0].latin1();
                  certificateRequest = files[1].latin1();

                }
                if( buffer4.find("-----BEGIN RSA PRIVATE KEY-----") == 0)
                {
                  // second is the private key, so first is the request
                  privateKey = files[1].latin1();
                  certificateRequest = files[0].latin1();
                }


                // Ask for the identity
                QString identityName;
                bool again = true;
                std::vector<std::string> identities;
                identities = user->getInfos( "Identities" );

                while( again )
                {
                  bool ok;
                  identityName = QInputDialog::getText("Nome da identidade", "Por favor, informe um nome para essa nova identidade (pode deixar esse campo em branco):",
                                                       QLineEdit::Normal, QString::null, &ok, this);


                  if( ok )
                  {
                    if(identityName.isEmpty())
                    {
                      identityName = "Default";
                    }
                  }
                  else
                  {
                    // Aborting certificate importation
                    QMessageBox::critical(this, "Erro", "Abortando a importao de certificado.");
                    return;
                  }

                  // Check if the provided identity already exists
                  if( std::find( identities.begin(), identities.end(), identityName.latin1() )
                      != identities.end() )
                  {
                    // the identity is already in the list
                    QMessageBox::critical(this ,"Erro", "Essa identidade j existe. Por favor, escolha outra.");
                    again = true;
                  }
                  else
                  {
                    again = false;
                  }
                }


                // Ask for the private key password.
                QString privateKeyPass;
                bool ok2;
                privateKeyPass = QInputDialog::getText("Senha da chave privada", "Informe a senha da chave privada utilizada quando a requisio de certificado foi gerada:",
                                                       QLineEdit::Password, QString::null, &ok2, this);

                if( !ok2 )
                {
                  // Aborting certificate importation
                  QMessageBox::critical(this, "Erro", "Abortando importao de certificado.");
                  return;
                }

                // Add the identity into the user account
                int ret = user->addIdentityFromP10( std::string(identityName.latin1()),
                                                    certificateRequest,
                                                    //                                                     std::string(certFilename.GetFullPath()),
                                                    std::string(filePath.latin1()),
                                                    privateKey,
                                                    privateKeyPass.latin1() );

                QString errorMsg;
                switch( ret )
                {
                case 0 : break;
                case -1: errorMsg = "No foi possvel carregar a chave privada gerada com a requisio de certificado.";
                  break;
                case -2: errorMsg = "No foi possvel carregar a requisio de certificado de origem.";
                  break;
                case -3: errorMsg = "A chave privada no corresponde  requisio de certificado.";
                  break;
                case -4: errorMsg = "No foi possvel carregar o certificado.";
                  break;
                case -5: errorMsg = "No foi possvel criar o objeto PKCS#12 intermedirio.";
                  break;
                case -6: errorMsg = "No foi possvel criar o arquivo temporrio para o objeto PKCS#12 em seu diretrio P12.";
                  break;
                case -7: errorMsg = "No foi possvel escrever o PKCS#12 temporrio em seu diretrio P12.";
                  break;
                  // addIdentityFromP12 errors:
                case -51: errorMsg = "No foi possvel carregar o PKCS#12 gerado.";
                  break;
                case -52: errorMsg = "Esse arquivo PKCS#12 j existe para esse usurio.";
                  break;
                case -53: errorMsg = "Essa identidade j existe na lista, por favor use um nome diferente.";
                  break;
                case -54: errorMsg = "Ocorreu um erro ao gravar o certificado no disco.";
                  break;
                case -55: errorMsg = "No foi possvel adicionar informao de identidade na lista de contatos.";
                  break;
                case -56: errorMsg = "No foi possvel gravar no disco um certificado CA includo no PKCS#12.";
                  break;
                case -57: errorMsg = "No foi possvel copiar o PKCS#12 em seu diretrio de usurio.";
                  break;
                default:  errorMsg = "Ocorreu um erro desconhecido.";
                  errorMsg += "(";
                  errorMsg += QString::number(ret) + ")";
                  break;
                }

                if(!errorMsg.isEmpty())
                {
                  QMessageBox::critical(this, "Erro", errorMsg);
                  return;
                }

                // The import was successfull, we can now remove
                // the temporary private key and request.
                std::remove(files[0].latin1());
                std::remove(files[1].latin1());
              }
            }

          }
          first.close();
          second.close();
        }
      }
    }

    done(QDialog::Accepted);   

  }
  else
  {
    QMessageBox::critical(this, "Erro", "Login ou senha incorreto.");
    //thiago: por minha conta:
    pwdCtrl->clear();
  }
}

void LoginFrame::slotWizard()
{
      NewUserWizard* wizi = new NewUserWizard(this);    
    
    if(wizi->exec() == QDialog::Rejected )
    {
      Cryptonit::User user = Cryptonit::User(wizi->getNewUserLogin());
      user.remove();
    }
    else
    {
      newUserLogin = wizi->getNewUserLogin().c_str();
    }
    //No se deve deletar um componente desta forma. O QT j o faz automaticamente.
    //delete wizi;
    fillUsersList();
}

void LoginFrame::slotExit()
{  
  QApplication::exit(0);
}

void LoginFrame::fillUsersList()
{
  QDir d(dirHome);
  if(!d.exists())
  {
    d.mkdir(dirHome);
    return;
  }


  QString filename;
  QString filespec;

  loginBox->clear();

  QStringList list = d.entryList();
  for(QStringList::iterator it = list.begin(); it != list.end(); ++it)
  {
    if((*it != "i18n") && (*it != ".") && (*it != ".."))
    {
      loginBox->insertItem(*it);
    }
  }

  // Select the newly created account if it exists
  if(!newUserLogin.isEmpty())
  {
    loginBox->setCurrentItem(
        loginBox->listBox()->index(
        loginBox->listBox()->findItem(newUserLogin)));
  }
  // Otherwise, select the first one
  else
  {
    if(loginBox->count())
    {
      loginBox->setCurrentItem(0);
    }
  }
}

void LoginFrame::hide()
{
  slotExit();
}


bool LoginFrame::licenseAccepted()
{
    return mLicenseAccepted;
}


Cryptonit::User* LoginFrame::loggedUser()
{
    return user;
}
