/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/

#include <string>

#include <qapplication.h>
#include <qmessagebox.h>
#include <qfile.h>
#include <qfiledialog.h>
#include <qheader.h>
#include <qlineedit.h>
#include <qprogressdialog.h>
#include <qfileinfo.h>

// #include "pathinfo.h"
#include "KeyStore.hh"
#include "SoftKeyStore.hh"
#include "EncryptingSettingsDlg.h"
#include "AddressBookFrame.h"
#include "../pkcs7.hh"
#include "mainwindowlistview.h"
#include "RecipientsDlg.h"
#include "VerifyCertDlg.h"
#include "AboutDlg.h"
#include "mainwindowlistview.h"
#include "SignSettingsDlg.h"

#include "AboutDlg.h"
#include "DecryptSettingsDlg.h"
#include "OverwriteDlg.h"
#include "VerifyCertDlg.h"
#include "VerifySettingsDlg.h"
#include "PasswordDlg.h"
#include "PropertiesFrame.h"
#include "qtpasswordmanager.h"
#include "keychoicedlg.h"
#include "tokenkeystore.h"


using namespace Cryptonit;

void MainWindow::init(Cryptonit::User* u)
{
  user = u;

  setupToolBar();

  //thiago: TODO:
  //createDropList();
  initKeyStores();


  //   setGeometry(x(), y(), 715, 300);
  setGeometry(x(), y(), 645, 300);
  dropList->addColumn( tr2i18n( "Caminho" ) );
  dropList->addColumn( tr2i18n( "Tamanho" ) );
  dropList->addColumn( tr2i18n( "Tipo" ) );
  dropList->header()->setLabel( 0, tr2i18n( "Caminho" ) );
  dropList->header()->setLabel( 1, tr2i18n( "Tamanho" ) );
  dropList->header()->setLabel( 2, tr2i18n( "Tipo" ) );

  enableButtons(false);
}

void MainWindow::setupToolBar()
{
  setUsesTextLabel(true);

  //   fileAction->setIconSet(QPixmap(dataPath() + "/pics/file_locked.xpm"));
  fileAction->addTo(mainToolBar);

  //   contactsAction->setIconSet(QPixmap(dataPath() + "/pics/addressbook.xpm"));
  contactsAction->addTo(mainToolBar);

  //   settingsAction->setIconSet(QPixmap(dataPath() + "/pics/config.xpm"));
  settingsAction->addTo(mainToolBar);

  //   encryptAction->setIconSet(QPixmap(dataPath() + "/pics/encrypted.xpm"));
  encryptAction->addTo(mainToolBar);

  //   decryptAction->setIconSet(QPixmap(dataPath() + "/pics/decrypted.xpm"));
  decryptAction->addTo(mainToolBar);

  //   signAction->setIconSet(QPixmap(dataPath() + "/pics/sign.xpm"));
  signAction->addTo(mainToolBar);

  //   verifyAction->setIconSet(QPixmap(dataPath() + "/pics/verify.xpm"));
  verifyAction->addTo(mainToolBar);

  //   selfAction->setIconSet(QPixmap(dataPath() + "/pics/exec.xpm"));
  //   selfAction->addTo(mainToolBar);

  //   aboutAction->setIconSet(QPixmap(dataPath() + "/pics/about.xpm"));
  aboutAction->addTo(mainToolBar);

  //   quitAction->setIconSet(QPixmap(dataPath() + "/pics/exit.xpm"));
  quitAction->addTo(mainToolBar);
}

void MainWindow::slotFile()
{
QString wildcard;
    wildcard = "Todos os arquivos (*.*);;"
               "Arquivo assinado (*.pkcs7 *.p7s);;"
               "Arquivo encriptado (*.pkcs7 *.p7m);;";
	                      
  QStringList files = QFileDialog::getOpenFileNames(
  			wildcard,
                        QDir::homeDirPath(),                        
                        this,
                        "openFiles",
                        "Selecione os arquivos para ..." );

  if(files.count() == 0)
  {
    enableButtons(false);
    return;
  }

  QStringList::Iterator it = files.begin();
  while( it != files.end() )
  {
    QString fileName = (QString)*it;
    new QListViewItem(dropList, fileName, getSize(fileName), getType(fileName));
    ++it;
  }
  enableButtons(true);
  return;
}

void MainWindow::slotContacts()
{

  AddressBookFrame abf(this, NULL, true, Qt::WType_Dialog);
  abf.setInfo(user, &keyStores);
  abf.exec();
}


void MainWindow::slotSettings()
{

  PropertiesFrame config(this);
  config.init(user, &keyStores);
  config.exec();
}


void MainWindow::slotEncrypt()
{



  if( dropList->childCount() == 0 )
  {
    QMessageBox::critical(this, "Error", "Nao existem arquivos para encriptar");
    return;
  }

  EncryptingSettingsDlg cd(this, NULL, true, Qt::WType_Dialog);
  if( cd.exec() == QDialog::Accepted )
  {
    bool remove = cd.getDeleteFile();
    bool leave = cd.getLeaveFile();
    QString path =  cd.getPath();

#ifdef DEBUG
    std::cerr << "Deleting files ? " << remove << std::endl;
    std::cerr << "Path : " << path << std::endl;
#endif

    RecipientsDlg rd(this, NULL, true, Qt::WType_Dialog);
    rd.setUser(user);
    
    
    if( rd.exec() == QDialog::Accepted)
    {
      std::vector<QString>* recipientList;
      if( (recipientList = rd.getRecipientList()) == NULL )
      {
        QMessageBox::critical(this, "Error", "Operao abortada porque nenhum destinatrio foi selecionado");
        return;
      }

      std::vector<QString> certificatesFiles;
      std::vector<QString>::iterator itr;
      for( itr = recipientList->begin(); itr != recipientList->end(); itr++ )
      {
        if( user->addressBook->getContactInfo
            ( itr->latin1(), "userCertificate" ) == "" )
        {
          QMessageBox::critical(this, "Error", "No h certificado associado com este contato" + QString(*itr) + "\nOperao abortada");
        }

        std::string certFile = user->getCertificatesDir() + QDir::separator() + user->addressBook->getContactInfo((*itr).latin1(), "userCertificate");
        certificatesFiles.push_back(QString(certFile.c_str()));
      }
      delete recipientList;
      if(certificatesFiles.size() != 0)
      {
#ifdef DEBUG
        std::cerr << "Certificate Checking" << std::endl;
#endif
        VerifyCertDlg vcd(this, NULL, true, Qt::WType_Dialog);
        vcd.setUser(user);
        vcd.verify(certificatesFiles);
        if (vcd.exec() == QDialog::Accepted )
        {
          encryptFiles( remove, leave, path, certificatesFiles );
        }
        else
        {
          QMessageBox::critical(this, "Error", "Nenhum destinatrio foi selecionado");
        }
      }
    }
  }
}


void MainWindow::slotDecrypt()
{
  if( dropList->childCount() == 0 )
  {
    QMessageBox::critical(this, "Erro", "No h arquivos para decriptar.");
    return;
  }


  DecryptSettingsDlg dd(this);
  if( dd.exec() == QDialog::Accepted )
  {
    decryptFiles( dd.getDeleteFile(), dd.getLeaveFile(), dd.getPath());
  }
}


void MainWindow::slotSign()
{
  if( dropList->childCount() == 0 )
  {
    QMessageBox::critical(this, "Error", "No existem arquivos para assinar");
    return;
  }

  SignSettingsDlg sd(this, NULL, true, Qt::WType_Dialog);
  if( sd.exec() == QDialog::Accepted )
  {
    std::vector<QString> certificatesFiles;
    /*
    //O codigo a seguir estah comentado visto que o metodo sd.getEncrypted() sempre retorna FALSE.
      if(sd.getEncrypted() && sd.getAttached()) {
          RecipientsDlg rd(this, -1, user, "Assinar : choose the recipients"));
          if( rd.showModal() == wxID_OK){
    #ifdef DEBUG
        std::cerr << "--> Encrypting" << std::endl;
    #endif
            
        std::vector<wxString>* recipientList;
        if( (recipientList = rd.getRecipientList()) == NULL ) {
            wxMessageDialog errorMsg
          (this, _("Operation aborted, because there is no recipient "
             "selected."), _("Error"), wxOK | wxICON_ERROR);
            errorMsg.ShowModal();
            return;
        }
         
        std::vector<wxString>::iterator itr;
        for( itr = recipientList->begin(); itr != recipientList->end(); itr++ ) {
            if( user->addressBook->getContactInfo
          (std::string(*itr), "userCertificate" ) == "") {
          wxString msg = _("There is no certificate associated with this "
               "contact: ") + wxString(*itr) + _("\nOperation aborted");
          wxMessageDialog errorMsg(this, msg,
                 _("Error"), wxOK | wxICON_ERROR);
          errorMsg.ShowModal();
            }
            
            wxFileName certificateFilename( user->getCertificatesDir().c_str() );
     
            wxString file = certificateFilename.GetFullPath();
            // pour les tests, doublons dans le path, le path du home est
            // deja present dans le path du certif
            file+= certificateFilename.GetPathSeparator(); 
            file+= user->addressBook->getContactInfo
          ( std::string(*itr), "userCertificate" ).c_str(); //porkos inside
            std::cerr << "userCertificate: " << file << std::endl;
          
            certificatesFiles.push_back( file.c_str() );
        }
        delete recipientList;
          }
          signFiles(sd.getDetached(),true **sd.getEncrypted()**,
              sd.getLeave(), sd.getDelete(),sd.getPath(),
              certificatesFiles);
      } else {
    */
    signFiles(sd.getDetached(),false /*sd.getEncrypted()*/,
              sd.getLeave(), sd.getDelete(),sd.getPath(),
              certificatesFiles /*will be ignored */);
    /*  }*/
  }

}


void MainWindow::slotVerify()
{
  if( dropList->childCount() == 0 )
  {
    QMessageBox::critical(this, "Erro", "No h arquivo para verificar.");
    return;
  }

  VerifySettingsDlg vsd(this);
  if(vsd.exec()== QDialog::Accepted)
  {
    verifyFiles(vsd.getLeave(), vsd.getDelete(), vsd.getPath(), vsd.getExtract() );
  }
}

void MainWindow::slotAbout()
{
  AboutDlg ab(this);
  ab.exec();
}

void MainWindow::closeEvent(QCloseEvent * e)
{
  QMainWindow::closeEvent(e);
  slotQuit();
}

void MainWindow::slotQuit()
{
  std::vector< Cryptonit::KeyStore *>::iterator i;
  std::vector< std::string > fields;
  for( i = keyStores.begin() ; i != keyStores.end() ; i++ )
  {
    delete *i;
  }

  if( ! (user->addressBook->save()) )
  {
    QString msg = "Ocorreu um erro ao gravar a lista de contatos: ";
    QMessageBox::critical(this, msg, "Erro");
  }

  if( ! (user->authorities->save()) )
  {
    QString msg = "Ocorreu um erro ao salvar o banco de dados de autoridades: ";
    QMessageBox::critical(this, msg, "Erro");
  }

  if( ! (user->saveToFile()) )
  {
    QString msg = "Ocorreu um erro ao gravar as preferncias de usurio: ";
    QMessageBox::critical(this, msg, "Erro");
  }

  delete user;

  keyStores.clear();
  QApplication::exit(0);
}

int MainWindow::decryptFiles(bool remove, bool leave, QString path)
{

  QProgressDialog pg( "Por favor, aguarde.", "Cancelar decriptao", 
  	dropList->childCount(), this, "progress", TRUE );  
  pg.setMinimumDuration(2);
  pg.setCaption("Decriptao em andamento...");
  Cryptonit::Key *pkey;


  bool alwaysOverwrite = false;

  int value = 0;

  QListViewItem* item = dropList->firstChild();
  while(item)
  {
    qApp->processEvents();
    if (pg.wasCanceled()) {
    	break;
    }
    pkey = NULL;
    Cryptonit::Certificate *matchingCertificate = NULL;

    Cryptonit::pkcs7 p7;

    int p7status = p7.read(item->text(0).latin1());

    if( p7status != Cryptonit::SUCCESS  ||  p7.isSigned() || p7.isDetached() )
    {
      
      pg.hide();
      qApp->processEvents();
      QString msg = item->text(0);
      msg +=" ";
      msg += "no est encriptado.";
      
      QMessageBox::critical( this, 0, msg);
      pg.show();
    }
    else
    {
    
      std::vector<PKCS7_RECIP_INFO> rinfo = p7.getRecipientInfos();
      std::vector<PKCS7_RECIP_INFO>::iterator rit;

      std::vector< Cryptonit::KeyStore *>::iterator storeIt;
      std::vector<Cryptonit::Certificate>::iterator certIt;

      Cryptonit::KeyStore *matchingKeyStore = NULL ;
      //try to find a matching certificate 'matchingCertificate'
      for( rit = rinfo.begin() ; rit!= rinfo.end() ; rit++ )
      {

        //iterate through all available keystores
        for( storeIt = keyStores.begin() ; storeIt != keyStores.end() ; storeIt++ )
        {
          std::vector<Cryptonit::Certificate> certVect = (*storeIt)->listCertificates();

          // iterate through all the certificates of this keystore.
          for( certIt = certVect.begin() ; certIt != certVect.end() ; certIt++ )
          {
            Cryptonit::dn issuer(rit->issuer_and_serial->issuer);
            if( certIt->getIssuerName().compare( issuer ) )
            {
              BIGNUM *bn=ASN1_INTEGER_to_BN(rit->issuer_and_serial->serial,NULL);
              std::string ret(BN_bn2hex(bn));
              if(strcmp(ret.c_str() , certIt->getSerialNumber().c_str()) == 0)
              {
                // find a matching certificate !
                matchingCertificate = new Cryptonit::Certificate(*certIt) ;
                matchingKeyStore = *storeIt;
                break;
              }
            }

          }

        }
      }

      if( matchingCertificate != NULL )
      {
        //now get the pkey from the store
        int ret = -1;
        while ( ret == -1 || ret == GETKEY_BAD_PASSWD  )
        {
//TODO: Luciano inserir aqui o tratamento para o token	
	  if (matchingKeyStore->getType() == PKCS11_KEYSTORE) {
	  	//((TokenKeyStore*)matchingKeyStore)->loadEngine();
	  }
          ret = matchingKeyStore->getKey(*matchingCertificate , &pkey );
          if(ret == GETKEY_BAD_PASSWD)
          {
	    pg.hide();
            QMessageBox::critical(this, "Erro", "Senha incorreta");
	    pg.show();
          }
        }

        if(pkey != NULL)
        {
          if(p7.decrypt(pkey, matchingCertificate) != Cryptonit::SUCCESS)
          {
            std::cerr << "Error while decrypting" << std::endl;
            if( ERR_GET_REASON( ERR_get_error()) == PKCS7_R_NO_RECIPIENT_MATCHES_CERTIFICATE)
            {
              pg.hide();
	      QString msg = "Erro ! : ";
              msg += item->text(0);
              msg += " " ;
              msg += "no parece ter sido encriptada a voc";	      
              QMessageBox::critical(this, "Erro", msg);
	      pg.show();
            }
            else
            {
	      pg.hide();
              QString msg = "Erro ! : ";
              msg += "No foi possvel decriptar.";
              msg += " " ;
              msg += item->text(0);	      
              QMessageBox::critical(this, "Erro", msg);
	      pg.show();
            }
            std::cerr << ERR_GET_REASON( ERR_get_error() )<< std::endl;
            pg.setProgress(value++);
            qApp->processEvents();
	    pg.setLabelText(item->text(0) + " : " + "Error");

          }
          else
          {
            // create decrypted filename , ie without the ending .pkcs7
            QString filename(item->text(0));
            QString file;

            if(leave)
            {
              file = filename;
            }
            else
            {
              file = path;
              if (!path.endsWith("/")) {
	        file += "/";
	      }
              file += filename.section('/', -1);
            }

            //we remove the .pkcs7 extension
            if(file.section('.', -1) == "pkcs7")
            {
              file = file.mid(0, file.length()-6);
            }

            // If the destination file already exists, ask the user
            // what to do
            bool overwriteDest = true;

            if ( !alwaysOverwrite )
            {
              if( QFile(file).exists() )
              {
                QString tmpFile( file );
                OverwriteDlg askOverwrite(this);
                int ret = askOverwrite.exec(tmpFile);

                if( ret == OverrideAlways )
                {
                  alwaysOverwrite = true;
                }
                else if( ret != OverrideYes )
                {
                  overwriteDest = false;
                }

              }
            }

            if( alwaysOverwrite || overwriteDest )
            {
              if(p7.writeDecrypted(file.latin1())== Cryptonit::SUCCESS)
              {
                pg.setProgress(value++);
		qApp->processEvents();
		pg.setLabelText(item->text(0));
                if(remove) QFile(item->text(0)).remove();
              }
              else
              {
                pg.setProgress(value++);
		qApp->processEvents();
		pg.setLabelText(file+ " : " + "Error");
              }
            }
            else
            {
              pg.setProgress(value++);
	      qApp->processEvents();
	      pg.setLabelText(file+ " : " + "Canceled");
            }
          }
	  delete pkey;
	  pkey = NULL;
	  std::cout << "Chave Privada apagada!!!" << std::endl;
        }
        else
        {
          if( ret != GETKEY_CANCELED && ret != GETKEY_SUCCESS )
          {
	    pg.hide();
            QMessageBox::critical(this, "Erro", "Chave privada invlida");
	    pg.show();
            pg.setProgress(value++);
	    qApp->processEvents();
	    pg.setLabelText(item->text(0) + " : " + "Error");
          }
          else
          {
            pg.setProgress(value++);
	    qApp->processEvents();
	    pg.setLabelText(item->text(0) + " : " + "Cancelado");
          }
        }
        delete matchingCertificate;

      }
      else
      {
        pg.hide();
        QString msg = item->text(0);
        msg +=" ";
        msg +="no foi encriptado.";
	pg.hide();
        QMessageBox::critical( this, "Erro", msg);
	pg.show();
      }

    }

    item = item->nextSibling();
  }
  pg.setProgress(dropList->childCount());
  dropList->clear();
  enableButtons(false);
  return Cryptonit::SUCCESS;
}

QString MainWindow::getSize( QString fileName )
{
  QString ssize;

  QFile *file = new QFile(fileName);
  if (file->exists())
  {
    uint fsize = file->size();
    delete file;

    if (fsize > 1024)
    {
      fsize /= 1024;
      if (fsize > 1024)
      {
        fsize /= 1024;
        ssize.sprintf("%d Mb", fsize);
      }
      else
        ssize.sprintf("%d Kb", fsize);
    }
    else
      ssize.sprintf("%d b", fsize);

    return ssize;
  }
  else
    return "-1";


}

QString MainWindow::getType( QString fileName )
{
  pkcs7 *p = new pkcs7();
  QString ret = "";

  if(p->read(fileName.latin1())==SUCCESS)
  {
    if(p->isSigned() && ! p->isDetached())
      ret = "Signed File";
    else if(p->isSigned() && p->isDetached())
      ret = "Detached signature";
    else if(p->isEncrypted())
      ret = "Encrypted File";
    else if(p->isSignedAndEncrypted())
      ret = "Signed & Encrypted File";
    else
      ret = "Data file";
  }
  else
    ret = "Data file";

  delete p;
  return ret;

}

void MainWindow::enableButtons(bool value)
{
  encryptAction->setEnabled(value);
  decryptAction->setEnabled(value);
  signAction->setEnabled(value);
  verifyAction->setEnabled(value);
}


void MainWindow::slotListViewEmpty()
{
  enableButtons(false);
}

int MainWindow::verifyFiles(bool leave, bool remove,
                              const QString &path, bool extract)
{

  //user certificate and PKCS#12

  QString X509Filename(user->getInfo("X509_Certificate").c_str());
  QString Pkcs12Filename(user->getInfo("PKCS12").c_str());

  X509Filename.prepend(QDir::separator());
  X509Filename.prepend(user->getCertificatesDir().c_str());
  Pkcs12Filename.prepend(QDir::separator());
  Pkcs12Filename.prepend(user->getP12Dir().c_str());

  
  //loading user x509
  Cryptonit::Certificate *userCert = new Cryptonit::Certificate();
  if( user->getInfo("X509_Certificate") != "" )
  {

    if(userCert->load(X509Filename.latin1()) != Cryptonit::SUCCESS)
    {
      QString msg = "Erro ao carregar ";
      msg += X509Filename;
      QMessageBox::critical(this, "Erro", msg);
      delete userCert;
      return -1;
    }
  }

  //signature verification now
  pkcs7 *p7=new pkcs7();

  QString CADir( user->getCACertificatesDir().c_str() );


  pkcs12 *p12 = NULL;
  pkcs8 *pkey = NULL;
  OpenSSL_add_all_algorithms();


  VerifyCertDlg vcd(this);
  vcd.setUser(user);

  QProgressDialog pg( "Por favor, aguarde.", "Cancelar verificao", 
  	dropList->childCount(), this, "progress", TRUE );  
  pg.setMinimumDuration(2);
  pg.setCaption("Verificao em andamento...");
  int value = 0;
  
  
  bool alwaysOverwrite = false;

  QListViewItem* item = dropList->firstChild();
  while(item)
  {
    qApp->processEvents();
    if (pg.wasCanceled()) {
    	break;
    }
    
    QString dataFile = "";
    
    if(p7->read(item->text(0).latin1())==Cryptonit::SUCCESS
        && (p7->isSigned() || p7->isSignedAndEncrypted()) )
    {
      
      if(p7->isSignedAndEncrypted())
      {
      
         if(p12 == NULL)
         {
            //loading pkcs12
            p12 = new pkcs12();
            PasswordDlg pd(this);
             
            QString password;

            bool loaded = false;
               
	    while(!loaded)
            {
              if(pd.exec() == QDialog::Accepted)
              {
                password = pd.passwordField->text();
                if(p12->load( Pkcs12Filename.latin1(), password.latin1())==Cryptonit::SUCCESS)
                {
                  loaded = true;
                }
                else
                {
                  pd.passwordField->clear();
                  QString msg = "Erro ao carregar chave privada ";
                  msg += "\n";
                  msg += "Senha invlida.";
		  pg.hide();
                  QMessageBox::critical(this, "Erro", msg);
		  pg.show();
                }
              }
              else
              { //cancel btn pressed
                delete p12;
		pg.hide();
                return -1;
              }
            }
            //now we load private key
            pkey = new pkcs8(p12->getKey());
        }
      }
      else if(p7->isDetached()){
         dataFile = item->text(0);
         dataFile = dataFile.mid(0, dataFile.length()-6);

         if(!QFileInfo(dataFile).exists())
         {
            //we can't find a file that match the signature, let the
            //user choose it
	    pg.hide();
            QMessageBox::warning(this, "Aviso",
                                   "Nenhuma assinatura separada foi encontrada. "
                                   "Por favor especifique na prxima janela.");
	      		   

            dataFile = QFileDialog::getOpenFileName(
                           QDir::currentDirPath(),
                           QString::null,
                           this,
                           0,
                           "Escolha o arquivo correspondente  assinatura");
	    pg.show();			   
          }

          std::cerr << "[DATA] : " << dataFile << std::endl;

      }
      
      
      std::vector<Certificate> *certList = new std::vector<Cryptonit::Certificate>;

      QStringList filename;

      QString CADir( user->getCACertificatesDir().c_str());
      QDir dir(CADir);
      filename = dir.entryList(QDir::Files);

      QStringList::iterator it;
      
      for(it = filename.begin(); it != filename.end(); ++it)
      {
          Cryptonit::Certificate cert;
          std::cout<<(*it).latin1()<<std::endl;
          QString certFilename =  user->getCACertificatesDir().c_str();
          certFilename += QDir::separator() + (*it);
          if(cert.load(certFilename)==Cryptonit::SUCCESS)
          {
             certList->push_back(cert);
             std::cout << cert.getHash() << std::endl;
          }
      }

      std::vector<PKCS7_SIGNER_INFO> info = p7->getSignerInfos();      
      std::vector<PKCS7_SIGNER_INFO>::iterator sit;
      int valid = -1;
      int index = 0;
      for(sit = info.begin() ; sit!= info.end() ; sit++)
      {      
      index++;
         //loading signer certificate;
	 
	 PKCS7_SIGNER_INFO *siAux;
	 siAux = PKCS7_SIGNER_INFO_new();
	 siAux->version = sit->version;
	 siAux->issuer_and_serial = sit->issuer_and_serial;
	 siAux->digest_alg = sit->digest_alg;
	 siAux->auth_attr = sit->auth_attr;
	 siAux->digest_enc_alg = sit->digest_enc_alg;
	 siAux->enc_digest = sit->enc_digest;
	 siAux->unauth_attr = sit->unauth_attr;
	 siAux->pkey = sit->pkey;
	
	
         //p7->getSignerCertificate(((PKCS7_SIGNER_INFO)*sit));
	 Cryptonit::Certificate &signer = p7->getSignerCertificate(siAux);
	 
	 
	 if(signer.getHash() == "")
         {
           pg.hide();	QString msg = "Erro ao carregar certificado do assinador.";
           msg+="\n";
           msg+= "Talvez " + item->text(0);
           msg+= " no seja um arquivo assinado.";	
           QMessageBox::critical(this, "Erro", msg);
	   pg.show();
         }
         else
         {
	 
           std::cerr << "SIGN :" << signer.getSubjectName().getValues( DN_DISPLAY_LONG | DN_DISPLAY_VALUE) << std::endl;
 
           std::cerr << item->text(0) << std::endl ;

           valid = -1;
           pg.setProgress(value);
	   qApp->processEvents();
	   pg.setLabelText(item->text(0));
           
	     if( p7->isSignedAndEncrypted() )
             {
               valid = p7->verify(signer, *pkey, *userCert,
                               CADir.latin1());
             }
             else if(!p7->isDetached())
             {
               valid = p7->verify(signer, *pkey, *userCert,
                               CADir.latin1());
             }
             else
             {
               if(!dataFile.isEmpty())
               {
                 valid = p7->verify(signer, *pkey, *userCert,
                                 CADir.latin1(), dataFile.latin1());
               }
             }
	     
          
	     //get the CA List
             std::vector<Cryptonit::Certificate> *CA = p7->getChainFromSigned(certList, signer);
             std::cerr << CA->size() << std::endl;
   
             pg.hide();
	     
	     vcd.verifySignature(valid, item->text(0) , CA);
	     
	     
	     pg.show();
          
           pg.setProgress(++value);
	   qApp->processEvents();
	   pg.setLabelText(item->text(0));
         } 
	  
      }
      
        if(extract && !p7->isDetached())
             {
               //extract data from signed file (attached signature)
               if(p7->extract(*pkey, *userCert))
               {
                 QString filename(item->text(0));
                 QString file;

                 if(leave)
                 {
                   file = filename;
                 }
                 else
                 {
		   file = path;
		   if (!path.endsWith("/")) {
		   	file += "/";
		   }
                   file += filename.section('/', -1);
                 }

                 //we remove the .pkcs7 extension
                 if(file.section('.', -1) == "pkcs7")
                 {
                   file = file.mid(0, file.length()-6);
                 }

                 // If the destination file already exists, ask the user
                 // what to do
                 bool overwriteDest = true;

                 if( !alwaysOverwrite )
                 {
                   if( QFile(file).exists() )
                   {

                     QString tmpFile( file );
                     OverwriteDlg askOverwrite(this);
                     int ret = askOverwrite.exec(tmpFile);

                     if( ret == OverrideAlways )
                     {
                       alwaysOverwrite = true;
                     }
                     else if( ret != OverrideYes )
                     {
                       overwriteDest = false;
                     }

                   }
                 }


                 if( alwaysOverwrite || overwriteDest )
                 {
                   p7->writeExtracted(file.latin1());
                   if(remove) QFile(item->text(0)).remove();
                 }
               }
             }
             else if(extract && !valid && !p7->isDetached())
             {
               QListViewItem* id = vcd.addOnRoot
                                (item->text(0), 0);
               vcd.addItem(id, "No foi possvel extrair dados do arquivo assinado (assinatura invlida)"
                        , 0);
               id->setOpen(true);
             }
    }
    else
    {
      QListViewItem* id = vcd.addOnRoot(item->text(0), 0);
      vcd.addItem(id, "Esse arquivo provavelmente no  um arquivo assinado",0);
      id->setOpen(true);
      pg.setProgress(++value);
      qApp->processEvents();
      pg.setLabelText(item->text(0));
    }

    item = item->nextSibling();
  }
  
  pg.setProgress(dropList->childCount());

  dropList->clear();
  enableButtons(false);

  vcd.exec();
  

  delete p7;
  delete userCert;
  delete pkey;
  //   wxEndBusyCursor();
  return Cryptonit::SUCCESS;
}


int MainWindow::encryptFiles(bool remove, bool leave, QString path, std::vector<QString>& certificates_files)
{
  std::vector<Certificate> certificates;
  OpenSSL_add_all_algorithms();
  bool error = false;
  if( certificates_files.size() == 0)
  {    
    QMessageBox::critical(this, "Error", "Lista de certificados vazia.");
    return -1;
  }
  std::vector<QString>::iterator itr;
  
  QProgressDialog pg( "Por favor, aguarde.", "Cancelar encriptao", 
  	dropList->childCount(), this, "progress", TRUE );  
  pg.setMinimumDuration(2);
  pg.setCaption("Encriptao em andamento...");
  int value = 0;
  bool alwaysOverwrite = false;
  QListViewItem* item = dropList->firstChild();
  while (item)
  {
    qApp->processEvents();
    if (pg.wasCanceled()) {
    	break;
    }
    pkcs7 *p7=new pkcs7();
    std::string cipher = user->getInfo("CipherAlgo");
    if (cipher == "") cipher = "AES_128";
    p7->setCipher( cipher );
    p7->setContentType( PKCS7Encrypted );
    for( itr = certificates_files.begin(); itr != certificates_files.end(); itr++ )
    {
      Certificate *certif = new Certificate();
      if( certif->load( itr->latin1() ) != SUCCESS )
      {
        QMessageBox::critical(this, "Error", "Erro na leitura do certificado: \n" + *itr);
        std::cerr << "Cannot load certificate '" << *itr << "'." << std::endl;
        delete p7;
        delete certif;
        return -1;
      }
      p7->addRecipient( *certif );
      delete certif;
    }
    QString file;
    if (leave)
    {
      //put encrypted files in the same directory than original files
      file = item->text(0);
    }
    else
    { //put them in "path"
      QFileInfo filename(item->text(0));
      QDir newPath(path);
      file = newPath.canonicalPath() + QDir::separator() + filename.fileName();
    }

    file += ".pkcs7";
    std::cerr << file << std::endl;

    std::string err = getErrorMsg(p7->encrypt(item->text(0).latin1()));
    if(err != "")
    {
      QMessageBox::critical(this, "Error", err.c_str());
      error = true ;
    }
    if(!error)
    {
      bool overwriteDest = true;

      if ( !alwaysOverwrite )
      {
        if( QFileInfo(file).exists() )
        {
          QString tmpFile( file );
          OverwriteDlg askOverwrite(this);
          int ret = askOverwrite.exec(tmpFile);

          if( ret == OverrideAlways )
          {
            alwaysOverwrite = true;
          }
          else if( ret != OverrideYes )
          {
            overwriteDest = false;
          }

        }
      }
      if( alwaysOverwrite || overwriteDest )
      {
        if(p7->write(file.latin1())==SUCCESS)
        {
          pg.setProgress(value++);
	  qApp->processEvents();
	  pg.setLabelText(item->text(0));
          if(remove) QFile(item->text(0)).remove();
        }
      }
      else
      {
        pg.setProgress(value++);
	qApp->processEvents();
	pg.setLabelText(file+ " : " + "Canceled");
      }

    }
    else
    {
      pg.setProgress(value++);
      qApp->processEvents();
      pg.setLabelText(file+ " : " + "Error");
      std::cerr << "Error: "<< file << std::endl;
      error = TRUE;
    }
    delete p7;
    item = item->nextSibling();
  }
  pg.setProgress(dropList->childCount());
  dropList->clear();
  enableButtons(false);
  if(error) return -1;
  return SUCCESS;
}


void MainWindow::initKeyStores()
{
  //OpenSSL KeyStore
  SoftKeyStore *sks = new SoftKeyStore( user );
  QTPasswordManager *pm  = new QTPasswordManager(this, "Fornea sua senha", TRUE, Qt::WStyle_DialogBorder);
  pm->init(user);
  sks->setPasswordManager( pm );
  TokenKeyStore *tks = new TokenKeyStore(user);
  tks->setPasswordManager(pm);
  
  keyStores.push_back( sks );
  keyStores.push_back(tks);
  
  if ( sks->count() == 0 )
  {
    encryptAction->setEnabled(FALSE);
    decryptAction->setEnabled(FALSE);
#ifdef USE_ENCRYPT_SELF
    //mainToolBar->EnableTool(MW_SELF_BTN_ID, false);
#endif

  }
}


int MainWindow::signFiles( bool detached, bool encrypted, bool leave, bool remove, const QString & path, std::vector<QString> & certificates_files )
{
  KeyChoiceDlg kcd(this, NULL, true, Qt::WType_Dialog);
  kcd.init(keyStores , user ,KEY_SIGN);
  Certificate userCert;
  int ret = -2;
#ifdef DEBUG
  std::cerr << "--> Signing" << std::endl;
  std::cerr << "    Looking for Key and Cert" << std::endl;
#endif
  Cryptonit::Key *pkey = kcd.getKeyAndCert( userCert , &ret);
#ifdef DEBUG
  std::cerr << "    Search over" << std::endl;
#endif
  if( ret == GETKEY_SUCCESS )
  {
#ifdef DEBUG
    std::cerr << "    Found Key" << std::endl;
#endif
    QDir dir(QString(user->getCACertificatesDir().c_str()));
    QStringList filename = dir.entryList(QDir::Files);

    std::vector<Certificate> *certList = new std::vector<Certificate>;
    QStringList::iterator it;
    Cryptonit::Certificate *cert;
    for(it = filename.begin(); it != filename.end(); ++it)
    {
      cert = new Certificate();
      if(cert->load((*it).latin1()) == Cryptonit::SUCCESS)
      {
        std::cerr<<(*it).latin1()<<std::endl;
        certList->push_back(*cert);
        std::cerr << cert->getHash() << std::endl;
      }
      else
      {
        delete cert;
      }
    }

    //get certificates chain for userCert
    std::vector<Certificate> *vect = userCert.getChain(certList);

    //loading the recipients Certificates
    std::vector<Certificate> *recipients = new std::vector<Certificate>;
    if( certificates_files.size()>0)
    {
      std::vector<QString>::iterator fileIt =  certificates_files.begin();
      while(fileIt !=  certificates_files.end())
      {
        Certificate *certif = new Certificate();

        if( certif->load( fileIt->latin1(), der_format ) != SUCCESS )
        {
          QString msg = "Erro carregando ";
          msg += fileIt->latin1();
          QMessageBox::critical(this, "Error", msg);
          std::cerr << "Cannot load certificate '" << *fileIt << "'." << std::endl;
          delete certif;
          vect->clear();
          delete vect;
          recipients->clear();
          delete recipients;
  	  delete pkey;
	  pkey = NULL;
	  std::cout << "Chave privada de assinatura foi apagada" << std::endl;
          return -1;
        }
        recipients->push_back(*certif);
        delete certif;
        fileIt++;
      }
    }

    /** signature **/
    pkcs7 *p7=new pkcs7();
    bool error = false;

    QProgressDialog pg( "Por favor, aguarde.", "Cancelar assinatura", 
    	dropList->childCount(), this, "progress", TRUE );  
    pg.setMinimumDuration(2);
    pg.setCaption("Assinatura em andamento...");
    int value = 0;
    if(encrypted)
    {
      std::string cipher = user->getInfo("CipherAlgo");
      if (cipher == "") cipher = "AES_128";
      p7->setCipher( cipher );
    }
    std::string digest =   user->getInfo("DigestAlgo");
    if( digest == "" ) digest = "SHA1";
    p7->setDigest( digest );
    bool alwaysOverwrite = false;
    QListViewItem* item = dropList->firstChild();
    while (item)
    {
       qApp->processEvents();
       if (pg.wasCanceled()) {
    	  break;
       }
      QString file;
      if (leave)
      {
        //put encrypted files in the same directory than original files
        file = item->text(0);
      }
      else
      { //put them in "path"
        QFileInfo filename(item->text(0));
        QDir newPath(path);
        file = newPath.canonicalPath() + QDir::separator() + filename.fileName();
      }
      
      if(p7->read(file) != SUCCESS) {
            file += ".pkcs7";
      }    
      
      std::cerr << file << std::endl;
      if(!encrypted)
      { //we will use pkcs7::sign()
        p7->setContentType( PKCS7Signed );
        std::cerr << "signature" << std::endl;
        p7->sign(item->text(0).latin1(),
                 userCert, *pkey, *vect, detached);
      }
      else
      { // we will use pkcs7::signAndEncrypt();
        p7->setContentType( PKCS7SignedEncrypted );
        std::cerr <<   p7->isSignedAndEncrypted()<< std::endl;
        int i = p7->signAndEncrypt(item->text(0).latin1(),
                                   userCert, *pkey, *vect, *recipients );
        std::cerr << i << std::endl;
      }

      bool overwriteDest = true;
      if( !alwaysOverwrite )
      {

        if( QFileInfo(file).exists() )
        {
          QString tmpFile( file );
          OverwriteDlg askOverwrite(this);
          int ret = askOverwrite.exec(tmpFile);

          if( ret == OverrideAlways )
          {
            alwaysOverwrite = true;
          }
          else if( ret != OverrideYes )
          {
            overwriteDest = false;
          }
        }
      }

      if( overwriteDest || alwaysOverwrite)
      {
      
        if(p7->write(file.latin1())== SUCCESS)
        {
	
          pg.setProgress(value++);
	  qApp->processEvents();
	  pg.setLabelText(item->text(0));
          if(remove) QFile(item->text(0)).remove();
        }
        else
        {
          pg.setProgress(value++);
	  qApp->processEvents();
	  pg.setLabelText(file+ " : " + "Error");
          error = TRUE;
        }
      }
      else
      {
        pg.setProgress(value++);
	qApp->processEvents();
	pg.setLabelText(file+ " : " + "Canceled");
      }
      item = item->nextSibling();

    }
    pg.setProgress(dropList->childCount());
    dropList->clear();
    enableButtons(false);
    vect->clear();
    delete vect;
    recipients->clear();
    delete recipients;
    delete p7;
    if (pkey != NULL) {
   	delete pkey;
	pkey = NULL;
	std::cout << "Chave privada de assinatura foi apagada" << std::endl;
    }  
    //  wxEndBusyCursor();
    if (!error) return SUCCESS;
  }
  if (pkey != NULL) {
  	delete pkey;
	pkey = NULL;
	std::cout << "Chave privada de assinatura foi apagada" << std::endl;
  } 
#ifdef DEBUG
  std::cerr << "<-- Signing" << std::endl;
#endif
  return -1;
}
