#ifndef CRLFETCHER_H
#define CRLFETCHER_H

#include <qobject.h>
#include <qstring.h>

class QNetworkOperation;
class QFile;

class CRLFetcher : public QObject
{
  Q_OBJECT
public:
  CRLFetcher(const QString& u, QObject *parent = 0, const char *name = 0);
  ~CRLFetcher();

  bool doFetch();
  QString savedPath();

private slots:
  void slotData(const QByteArray & data, QNetworkOperation * op);
  void slotFinished(QNetworkOperation * op);

private:
  void clearFile();
  
  enum { StreamInit, StreamDoneError, StreamDone, StreamPending };

  int     mStreamStatus;
  QFile*  mOutputFile;
  QString uri;
  QString mSavedFile;
};

#endif
