/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/

#import <qmessagebox.h>
#import "CertificateViewer.h"

void KeyChoiceDlg::onCVBtn()
{
  int i = keyCombo->currentItem();
  if( i == -1 )
  {
    i = 0;
  }
  StoreAndKey *sak =  (StoreAndKey *) storeAndKeys[i];
  if( sak != NULL )
  {
    Certificate c = Certificate( *(sak->c) );
    CertificateViewer cv(this);
    cv.init(c, user, true);
    cv.exec();
  }

}


void KeyChoiceDlg::fillKeyCombo( keyType type )
{
  int i=0;
  std::vector<KeyStore *>::iterator storeIt;
  //Apaga a colecao de chaves e certificados anteriores.
  for (i=0; i<storeAndKeys.size(); i++)
  {
    StoreAndKey *sak = (StoreAndKey*)storeAndKeys[i];
    Certificate *c = sak->c;
    delete c;
    free(sak);
  }
  storeAndKeys.clear();
  for( storeIt = stores.begin() ; storeIt != stores.end() ; storeIt++ )
  {
    if (*storeIt)
    {
      std::vector<Certificate> listCertif =(* storeIt)->listCertificates();
      std::vector<Certificate>::iterator certIt;
      for( certIt = listCertif.begin() ; certIt != listCertif.end() ; certIt++ )
      {
        if( certIt->isForSigningAndEncrypting() || certIt->isForSigning() )
        {
          StoreAndKey *sak = (StoreAndKey *) malloc(sizeof( StoreAndKey ));
          sak->ks = *storeIt;
          Certificate *c = new Certificate( *certIt );
          sak->c = c;
          QString cert = certIt->getSubjectName().getValue("CN").c_str();
          keyCombo->insertItem(cert, -1);
          storeAndKeys.push_back(sak);
        }
      }
    }
  }

}



void KeyChoiceDlg::init( std::vector<KeyStore *> s, User *u, keyType type )
{
    user = u;
    stores = s;
  fillKeyCombo( type );
  if ( keyCombo->count() == 0 )
  {
    okBtn->setEnabled(FALSE);
    cvBtn->setEnabled(FALSE);
    keyCombo->insertItem("Nenhuma chave disponvel", -1);
    keyCombo->setEnabled(FALSE);
  }
  keyCombo->setCurrentItem(0);
}


void KeyChoiceDlg::destroy()
{
  // no key so no data to free (to avoid wxWindows exception warning under win32)
  if( keyCombo->isEnabled() == FALSE)
  {
    return;
  }
  for (int i=0; i<storeAndKeys.size(); i++)
  {
    StoreAndKey *sak = (StoreAndKey*)storeAndKeys[i];
    Certificate *c = sak->c;
    delete c;
    free(sak);
  }

}


Cryptonit::Key* KeyChoiceDlg::getKeyAndCert( Certificate & c, int * r )
{
  if (exec() == QDialog::Accepted)
  {
    int i = keyCombo->currentItem();
    //if no entry selected, auto select the first one
    if( i == -1 )
    {
      i = 0;
    }
    StoreAndKey *sak =  (StoreAndKey *) storeAndKeys[i];
    Cryptonit::Key *k = NULL;
    int ret = -1 ;
    if( sak != NULL )
    {
      c = Certificate( *(sak->c) );
      while( ret == GETKEY_BAD_PASSWD || ret == -1 )
      {
        ret = sak->ks->getKey( c , &k );
        if(ret == GETKEY_BAD_PASSWD)
        {
          QMessageBox::critical(this, "Eror", "Senha incorreta");
        }
      }
      *r = ret;
      return k;
    }
    *r = GETKEY_INVALID;
  }
  return NULL;

}
