# RPM specfile for MUSCLE PC/SC Lite

Name:           pcsc-lite
Version:        1.2.9
Release:        beta7
License:        BSD
URL:            http://www.linuxnet.com/middle.html
Buildroot:      %{_tmppath}/%{name}-%{version}-%{release}-root
Source0:        pcsc-lite-1.2.9-beta7.tar.gz
Source1: 	pcscd.script
Group:          System/Daemons
Requires: 	flex
Summary:        MUSCLE PC/SC Smartcard Framework for Linux

%description
pcscd is the daemon program for PC/SC Lite. It is a resource manager that
coordinates communications with Smart Card readers and Smart Cards that are
connected to the system.
The purpose of PC/SC Lite is to provide a MS-Windows(R) SCard interface in a
very small form factor for communicating to smartcards and readers.
PC/SC Lite uses the same winscard API as used under MS-Windows(R).

In addition to this package, you'll also need to install driver modules
for the Smart Card types you use.  Look at
<http://www.linuxnet.com/sourcedrivers.html>.

# Special installation paths
%define sbindir         /sbin
%define slibdir         /lib
%define sconfdir       /etc/

%define initdir         /etc/init.d
%define rc_topdir       %{initdir}

%define rc_confdir      /etc
%define rc_conffile     pcscd
%define driverdir       %{_prefix}/pcsc/drivers

%prep
%setup -n pcsc-lite-1.2.9-beta7

%build
./bootstrap
if [ -z '%{_prefix}' ]
  prefix="/usr"
then 
  prefix=%{_prefix}
fi
 
CFLAGS="${CFLAGS-$RPM_OPT_FLAGS}" \
./configure \
    --prefix=/usr \
    --enable-debugatr \
    --mandir=%{_mandir} 
make

%install
rm -rf %{buildroot}
make install DESTDIR=%{buildroot} datadir=%{_docdir}/%{name}
mkdir -p %{buildroot}%{initdir}
#cp pcscd %{buildroot}%{initdir}/pcscd
cp %SOURCE1  %{buildroot}%{initdir}/pcscd
chmod 755 %{buildroot}%{initdir}/pcscd

%clean
rm -rf %{buildroot}

%post
if ! test -d /usr/pcsc/drivers; then
  mkdir -p %{driverdir}
fi

if test -x /sbin/ldconfig; then /sbin/ldconfig %{_libdir}; fi
if test -x /sbin/chkconfig; then /sbin/chkconfig --add pcscd; fi
%_post_service pcscd

%postun
if [ $1 = 0 ]; then
  if test -x /sbin/ldconfig; then /sbin/ldconfig %{_libdir}; fi
fi

if [ -d %{driverdir} ]; then
   res=`ls %{driverdir}`
   if [ -z "$res" ]; then
    rm -rf %{_prefix}/pcsc
   fi
fi

%preun
if [ -x %{initdir}/pcscd ]; then
  str=`%{initdir}/pcscd status | grep stopped`    
  if [ -z "$str" ]; then    
    %{initdir}/pcscd stop
  fi
fi
if test -x /sbin/chkconfig; then /sbin/chkconfig --del pcscd; fi


%files
%defattr(-,root,root)
%{_bindir}/*
%{_sbindir}/*
%{initdir}/pcscd
%config %{sconfdir}/reader.conf.d/reader.conf
%doc AUTHORS COPYING ChangeLog DRIVERS HELP NEWS README* SECURITY

%doc %{_datadir}/doc/pcsc-lite/* 
%{_mandir}/man1/*
%{_mandir}/man5/*
%{_mandir}/man8/*

# The shared libs package just gets the versioned run-time library
# so that we can have several versions installed without file conflicts.
%defattr(-,root,root)
%{_libdir}/lib*.so.*

# The rest goes into the devel package.
%defattr(-,root,root)
%{_libdir}/lib*.so
%{_libdir}/lib*.*a
%{_includedir}/*

%{_libdir}/pkgconfig/libpcsclite.pc

